use serenity::{
    client::Context,
    http::Http,
    model::{channel::Message, id::ChannelId, prelude::ReactionType},
    builder::{CreateEmbed, CreateMessage}
};

use std::sync::Arc;

pub async fn send_embed(ctx: &Context, msg: &Message, text: &str) {
    let embed = CreateEmbed::new().description(text).color(0xf542bf);
    let builder = CreateMessage::new().embed(embed);

    let res = msg
        .channel_id
        .send_message(&ctx.http, builder)
        .await;
    if let Err(why) = res {
        println!("Error sending embed: {:?}", why);
    };
}

pub async fn send_embed_http(channel_id: ChannelId, http: Arc<Http>, text: &str) {
    let embed = CreateEmbed::new().description(text).color(0xf542bf);
    let builder = CreateMessage::new().embed(embed);

    let res = channel_id
        .send_message(http, builder)
        .await;

    if let Err(why) = res {
        println!("Error sending embed: {:?}", why);
    };
}

pub async fn message_react(ctx: &Context, msg: &Message, emoji: &str) {
    let res = msg
        .react(&ctx.http, ReactionType::Unicode(emoji.to_string()))
        .await;
    if let Err(why) = res {
        println!("Error reacting to message: {:?}", why);
    }
}
